/* Copyright (c) 2022, Canaan Bright Sight Co., Ltd
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
 * CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/******************************************************************************
  File Name     : isp_wdr_coeff.c
  Version       : Initial Draft
  Author        : 
  Created       : 
  Description   : 
  History       :
  1.Date        : 
    Author      :
    Modification: Created file

******************************************************************************/
/*****************************************************************************
* 3 frame wdr coff
*****************************************************************************/
/*
*WDR L3 table configuration
*/
int ISP_2K_WDR_L3_TABLE[1024] =
{       
    0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0xFC9,
	0xEF0,
	0xE1D,
	0xD60,
	0xCB6,
	0xC1C,
	0xB90,
	0xB10,
	0xA9A,
	0xA2E,
	0x9CA,
	0x96D,
	0x916,
	0x8C6,
	0x87A,
	0x834,
	0x7F1,
	0x7B3,
	0x778,
	0x740,
	0x70C,
	0x6DA,
	0x6AA,
	0x67D,
	0x653,
	0x62A,
	0x603,
	0x5DE,
	0x5BA,
	0x598,
	0x577,
	0x558,
	0x53A,
	0x51D,
	0x501,
	0x4E7,
	0x4CD,
	0x4B4,
	0x49C,
	0x485,
	0x46F,
	0x459,
	0x444,
	0x430,
	0x41D,
	0x40A,
	0x3F7,
	0x3E6,
	0x3D4,
	0x3C4,
	0x3B3,
	0x3A4,
	0x394,
	0x385,
	0x377,
	0x369,
	0x35B,
	0x34D,
	0x340,
	0x334,
	0x327,
	0x31B,
	0x30F,
	0x304,
	0x2F8,
	0x2ED,
	0x2E3,
	0x2D8,
	0x2CE,
	0x2C4,
	0x2BA,
	0x2B1,
	0x2A7,
	0x29E,
	0x295,
	0x28C,
	0x284,
	0x27B,
	0x273,
	0x26B,
	0x263,
	0x25B,
	0x253,
	0x24C,
	0x244,
	0x23D,
	0x236,
	0x22F,
	0x228,
	0x222,
	0x21B,
	0x214,
	0x20E,
	0x208,
	0x202,
	0x1FC,
	0x1F6,
	0x1F0,
	0x1EA,
	0x1E4,
	0x1DF,
	0x1D9,
	0x1D4,
	0x1CF,
	0x1CA,
	0x1C4,
	0x1BF,
	0x1BA,
	0x1B5,
	0x1B1,
	0x1AC,
	0x1A7,
	0x1A3,
	0x19E,
	0x19A,
	0x195,
	0x191,
	0x18C,
	0x188,
	0x184,
	0x180,
	0x17C,
	0x178,
	0x174,
	0x170,
	0x16C,
	0x168,
	0x165,
	0x161,
	0x15D,
	0x15A,
	0x156,
	0x153,
	0x14F,
	0x14C,
	0x148,
	0x145,
	0x142,
	0x13F,
	0x13B,
	0x138,
	0x135,
	0x132,
	0x12F,
	0x12C,
	0x129,
	0x126,
	0x123,
	0x120,
	0x11D,
	0x11A,
	0x117,
	0x115,
	0x112,
	0x10F,
	0x10D,
	0x10A,
	0x107,
	0x105,
	0x102,
	0x100,
	0xFD,
	0xFB,
	0xF8,
	0xF6,
	0xF3,
	0xF1,
	0xEF,
	0xEC,
	0xEA,
	0xE8,
	0xE5,
	0xE3,
	0xE1,
	0xDF,
	0xDD,
	0xDA,
	0xD8,
	0xD6,
	0xD4,
	0xD2,
	0xD0,
	0xCE,
	0xCC,
	0xCA,
	0xC8,
	0xC6,
	0xC4,
	0xC2,
	0xC0,
	0xBE,
	0xBD,
	0xBB,
	0xB9,
	0xB7,
	0xB5,
	0xB3,
	0xB2,
	0xB0,
	0xAE,
	0xAC,
	0xAB,
	0xA9,
	0xA7,
	0xA6,
	0xA4,
	0xA2,
	0xA1,
	0x9F,
	0x9E,
	0x9C,
	0x9A,
	0x99,
	0x97,
	0x96,
	0x94,
	0x93,
	0x91,
	0x90,
	0x8E,
	0x8D,
	0x8B,
	0x8A,
	0x88,
	0x87,
	0x86,
	0x84,
	0x83,
	0x82,
	0x80,
	0x7F,
	0x7D,
	0x7C,
	0x7B,
	0x79,
	0x78,
	0x77,
	0x76,
	0x74,
	0x73,
	0x72,
	0x71,
	0x6E,
	0x6C,
	0x69,
	0x67,
	0x65,
	0x62,
	0x60,
	0x5E,
	0x5C,
	0x59,
	0x57,
	0x55,
	0x53,
	0x51,
	0x4F,
	0x4D,
	0x4B,
	0x49,
	0x47,
	0x45,
	0x43,
	0x41,
	0x40,
	0x3E,
	0x3C,
	0x3A,
	0x38,
	0x37,
	0x35,
	0x33,
	0x32,
	0x30,
	0x2E,
	0x2D,
	0x2B,
	0x29,
	0x28,
	0x26,
	0x25,
	0x23,
	0x22,
	0x20,
	0x1F,
	0x1D,
	0x1C,
	0x1B,
	0x19,
	0x18,
	0x16,
	0x15,
	0x14,
	0x12,
	0x11,
	0x10,
	0xF,
	0xD,
	0xC,
	0xB,
	0xA,
	0x8,
	0x7,
	0x6,
	0x5,
	0x4,
	0x2,
	0x1,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0
};
/*
*WDR M3 table confiuration
*/
int ISP_2K_WDR_M3_TABLE[1024] =
{       
    0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1003,
	0x10EC,
	0x11C7,
	0x1294,
	0x1354,
	0x1407,
	0x14B0,
	0x154E,
	0x15E2,
	0x166D,
	0x16EF,
	0x176A,
	0x17DC,
	0x1847,
	0x18AC,
	0x190A,
	0x1962,
	0x19B4,
	0x1A01,
	0x1A49,
	0x1A8C,
	0x1ACB,
	0x1B06,
	0x1B3C,
	0x1B6F,
	0x1B9E,
	0x1BCA,
	0x1BF3,
	0x1C18,
	0x1C3B,
	0x1C5B,
	0x1C78,
	0x1C93,
	0x1CAC,
	0x1CC2,
	0x1CD7,
	0x1CE9,
	0x1CFA,
	0x1D08,
	0x1D16,
	0x1D21,
	0x1D2B,
	0x1D34,
	0x1D3B,
	0x1D41,
	0x1D45,
	0x1D49,
	0x1D4B,
	0x1D4C,
	0x1D4D,
	0x1D4C,
	0x1D4A,
	0x1D48,
	0x1D45,
	0x1D40,
	0x1D3C,
	0x1D36,
	0x1D30,
	0x1D29,
	0x1D22,
	0x1D1A,
	0x1D11,
	0x1D08,
	0x1CFF,
	0x1CF5,
	0x1CEA,
	0x1CDF,
	0x1CD4,
	0x1CC8,
	0x1CBC,
	0x1CB0,
	0x1CA3,
	0x1C97,
	0x1C89,
	0x1C7C,
	0x1C6E,
	0x1C60,
	0x1C52,
	0x1C43,
	0x1C35,
	0x1C26,
	0x1C17,
	0x1C07,
	0x1BF8,
	0x1BE9,
	0x1BD9,
	0x1BC9,
	0x1BB9,
	0x1BA9,
	0x1B99,
	0x1B89,
	0x1B78,
	0x1B68,
	0x1B58,
	0x1B47,
	0x1B36,
	0x1B26,
	0x1B15,
	0x1B04,
	0x1AF3,
	0x1AE3,
	0x1AD2,
	0x1AC1,
	0x1AB0,
	0x1A9F,
	0x1A8E,
	0x1A7D,
	0x1A6C,
	0x1A5B,
	0x1A4A,
	0x1A39,
	0x1A28,
	0x1A17,
	0x1A06,
	0x19F5,
	0x19E4,
	0x19D3,
	0x19C2,
	0x19B1,
	0x19A0,
	0x198F,
	0x197E,
	0x196D,
	0x195D,
	0x194C,
	0x193B,
	0x192A,
	0x191A,
	0x1909,
	0x18F8,
	0x18E8,
	0x18D7,
	0x18C7,
	0x18B7,
	0x18A6,
	0x1896,
	0x1886,
	0x1875,
	0x1865,
	0x1855,
	0x1845,
	0x1835,
	0x1825,
	0x1815,
	0x1805,
	0x17F5,
	0x17E5,
	0x17D6,
	0x17C6,
	0x17B6,
	0x17A7,
	0x1797,
	0x1788,
	0x1778,
	0x1769,
	0x175A,
	0x174B,
	0x173B,
	0x172C,
	0x171D,
	0x170E,
	0x16FF,
	0x16F0,
	0x16E2,
	0x16D3,
	0x16C4,
	0x16B5,
	0x16A7,
	0x1698,
	0x168A,
	0x167B,
	0x166D,
	0x165F,
	0x1650,
	0x1642,
	0x1634,
	0x1626,
	0x1618,
	0x160A,
	0x15FC,
	0x15EE,
	0x15E0,
	0x15D3,
	0x15C5,
	0x15B7,
	0x15AA,
	0x159C,
	0x158F,
	0x1581,
	0x1574,
	0x1567,
	0x155A,
	0x154C,
	0x1532,
	0x1518,
	0x14FE,
	0x14E5,
	0x14CC,
	0x14B2,
	0x149A,
	0x1481,
	0x1468,
	0x1450,
	0x1438,
	0x1420,
	0x1409,
	0x13F1,
	0x13DA,
	0x13C3,
	0x13AC,
	0x1395,
	0x137F,
	0x1369,
	0x1353,
	0x133D,
	0x1327,
	0x1311,
	0x12FC,
	0x12E7,
	0x12D2,
	0x12BD,
	0x12A8,
	0x1294,
	0x127F,
	0x126B,
	0x1257,
	0x1244,
	0x1230,
	0x121C,
	0x1209,
	0x11F6,
	0x11E3,
	0x11D0,
	0x11BD,
	0x11AB,
	0x1198,
	0x1186,
	0x1174,
	0x1162,
	0x1150,
	0x113E,
	0x112D,
	0x111B,
	0x110A,
	0x10F9,
	0x10E8,
	0x10D7,
	0x10C6,
	0x10B6,
	0x10A5,
	0x1095,
	0x1084,
	0x1074,
	0x1064,
	0x1054,
	0x1045,
	0x1035,
	0x1025,
	0x1016,
	0x1007,
	0xFF6,
	0xFE4,
	0xFD2,
	0xFC1,
	0xFAF,
	0xF9E,
	0xF8D,
	0xF7C,
	0xF6B,
	0xF5A,
	0xF49,
	0xF39,
	0xF29,
	0xF19,
	0xF09,
	0xEF9,
	0xEE9,
	0xEDA,
	0xECA,
	0xEBB,
	0xEAC,
	0xE9D,
	0xE8E,
	0xE7F,
	0xE70,
	0xE62,
	0xE53,
	0xE45,
	0xE37,
	0xE29,
	0xE1B,
	0xE0D,
	0xDFF,
	0xDF2,
	0xDE4,
	0xDD7,
	0xDCA,
	0xDBC,
	0xDAF,
	0xDA2,
	0xD96,
	0xD89,
	0xD7C,
	0xD70,
	0xD63,
	0xD57,
	0xD4A,
	0xD3E,
	0xD32,
	0xD26,
	0xD1A,
	0xD0E,
	0xD03,
	0xCF7,
	0xCEB,
	0xCE0,
	0xCD4,
	0xCC9,
	0xCBE,
	0xCB3,
	0xCA8,
	0xC92,
	0xC7C,
	0xC67,
	0xC52,
	0xC3D,
	0xC29,
	0xC15,
	0xC01,
	0xBED,
	0xBDA,
	0xBC7,
	0xBB4,
	0xBA1,
	0xB8F,
	0xB7D,
	0xB6B,
	0xB59,
	0xB48,
	0xB37,
	0xB26,
	0xB15,
	0xB04,
	0xAF4,
	0xAE4,
	0xAD4,
	0xAC4,
	0xAB4,
	0xAA5,
	0xA96,
	0xA86,
	0xA78,
	0xA69,
	0xA5A,
	0xA4C,
	0xA3E,
	0xA30,
	0xA22,
	0xA14,
	0xA06,
	0x9F9,
	0x9EC,
	0x9DE,
	0x9D1,
	0x9C5,
	0x9B8,
	0x9AB,
	0x99F,
	0x992,
	0x986,
	0x97A,
	0x96E,
	0x962,
	0x956,
	0x94B,
	0x93F,
	0x934,
	0x929,
	0x91E,
	0x912,
	0x908,
	0x8FD,
	0x8F2,
	0x8E7,
	0x8DD,
	0x8D2,
	0x8C8,
	0x8BE,
	0x8B4,
	0x8AA,
	0x8A0,
	0x896,
	0x88C,
	0x882,
	0x879,
	0x86F,
	0x866,
	0x85D,
	0x853,
	0x84A,
	0x841,
	0x838,
	0x82F,
	0x826,
	0x81E,
	0x815,
	0x80C,
	0x804,
	0x7FB,
	0x7F3,
	0x7EA,
	0x7E2,
	0x7DA,
	0x7D2,
	0x7CA,
	0x7C2,
	0x7BA,
	0x7B2,
	0x7AA,
	0x7A2,
	0x79B,
	0x793,
	0x78C,
	0x784,
	0x77D,
	0x775,
	0x76E,
	0x767,
	0x760,
	0x758,
	0x751,
	0x74A,
	0x743,
	0x73C,
	0x735,
	0x72F,
	0x728,
	0x721,
	0x71A,
	0x714,
	0x70D,
	0x707,
	0x700,
	0x6FA,
	0x6F3,
	0x6ED,
	0x6E7,
	0x6E0,
	0x6DA,
	0x6CE,
	0x6C2,
	0x6B6,
	0x6AA,
	0x69F,
	0x693,
	0x688,
	0x67D,
	0x672,
	0x667,
	0x65C,
	0x651,
	0x647,
	0x63D,
	0x633,
	0x628,
	0x61F,
	0x615,
	0x60B,
	0x602,
	0x5F8,
	0x5EF,
	0x5E6,
	0x5DC,
	0x5D3,
	0x5CB,
	0x5C2,
	0x5B9,
	0x5B1,
	0x5A8,
	0x5A0,
	0x597,
	0x58F,
	0x587,
	0x57F,
	0x577,
	0x56F,
	0x568,
	0x560,
	0x558,
	0x551,
	0x54A,
	0x542,
	0x53B,
	0x534,
	0x52D,
	0x526,
	0x51F,
	0x518,
	0x511,
	0x50A,
	0x503,
	0x4FD,
	0x4F6,
	0x4F0,
	0x4E9,
	0x4E3,
	0x4DD,
	0x4D7,
	0x4D0,
	0x4CA,
	0x4C4,
	0x4BE,
	0x4B8,
	0x4B2,
	0x4AD,
	0x4A7,
	0x4A1,
	0x49B,
	0x496,
	0x490,
	0x48B,
	0x485,
	0x480,
	0x47A,
	0x475,
	0x470,
	0x46B,
	0x465,
	0x460,
	0x45B,
	0x456,
	0x451,
	0x44C,
	0x447,
	0x442,
	0x43E,
	0x439,
	0x434,
	0x42F,
	0x42B,
	0x426,
	0x421,
	0x41D,
	0x418,
	0x414,
	0x40F,
	0x40B,
	0x407,
	0x402,
	0x3FE,
	0x3FA,
	0x3F5,
	0x3F1,
	0x3ED,
	0x3E9,
	0x3E5,
	0x3E1,
	0x3DD,
	0x3D9,
	0x3D5,
	0x3D1,
	0x3CD,
	0x3C9,
	0x3C5,
	0x3C1,
	0x3BD,
	0x3B9,
	0x3B6,
	0x3B2,
	0x3AE,
	0x3AB,
	0x3A7,
	0x3A3,
	0x3A0,
	0x39C,
	0x399,
	0x395,
	0x38E,
	0x387,
	0x380,
	0x37A,
	0x373,
	0x36D,
	0x366,
	0x360,
	0x35A,
	0x354,
	0x34D,
	0x347,
	0x341,
	0x33C,
	0x336,
	0x330,
	0x32A,
	0x325,
	0x31F,
	0x31A,
	0x315,
	0x30F,
	0x30A,
	0x305,
	0x300,
	0x2FB,
	0x2F6,
	0x2F1,
	0x2EC,
	0x2E7,
	0x2E2,
	0x2DE,
	0x2D9,
	0x2D4,
	0x2D0,
	0x2CB,
	0x2C7,
	0x2C2,
	0x2BE,
	0x2BA,
	0x2B5,
	0x2B1,
	0x2AD,
	0x2A9,
	0x2A5,
	0x2A1,
	0x29D,
	0x299,
	0x295,
	0x291,
	0x28D,
	0x289,
	0x285,
	0x282,
	0x27E,
	0x27A,
	0x277,
	0x273,
	0x26F,
	0x26C,
	0x268,
	0x265,
	0x262,
	0x25E,
	0x25B,
	0x257,
	0x254,
	0x251,
	0x24E,
	0x24A,
	0x247,
	0x244,
	0x241,
	0x23E,
	0x23B,
	0x238,
	0x235,
	0x232,
	0x22F,
	0x22C,
	0x229,
	0x226,
	0x223,
	0x220,
	0x21D,
	0x21B,
	0x218,
	0x215,
	0x212,
	0x210,
	0x20D,
	0x20A,
	0x208,
	0x205,
	0x203,
	0x200,
	0x1FD,
	0x1FB,
	0x1F8,
	0x1F6,
	0x1F3,
	0x1F1,
	0x1EF,
	0x1EC,
	0x1EA,
	0x1E7,
	0x1E5,
	0x1E3,
	0x1E0,
	0x1DE,
	0x1DC,
	0x1D9,
	0x1D7,
	0x1D5,
	0x1D3,
	0x1D0,
	0x1CE,
	0x1CC,
	0x1CA,
	0x1C8,
	0x1C6,
	0x1C4,
	0x1C1,
	0x1BF,
	0x1BD,
	0x1BB,
	0x1B9,
	0x1B7,
	0x1B3,
	0x1AF,
	0x1AB,
	0x1A7,
	0x1A4,
	0x1A0,
	0x19C,
	0x199,
	0x195,
	0x191,
	0x18E,
	0x18A,
	0x187,
	0x184,
	0x180,
	0x17D,
	0x17A,
	0x177,
	0x173,
	0x170,
	0x16D,
	0x16A,
	0x167,
	0x164,
	0x161,
	0x15E,
	0x15B,
	0x158,
	0x156,
	0x153,
	0x150,
	0x14D,
	0x14B,
	0x148,
	0x145,
	0x143,
	0x140,
	0x13E,
	0x13B,
	0x139,
	0x136,
	0x134,
	0x131,
	0x12F,
	0x12C,
	0x12A,
	0x128,
	0x125,
	0x123,
	0x121,
	0x11F,
	0x11C,
	0x11A,
	0x118,
	0x116,
	0x114,
	0x112,
	0x110,
	0x10E,
	0x10C,
	0x10A,
	0x108,
	0x106,
	0x104,
	0x102,
	0x100,
	0xFE,
	0xFC,
	0xFA,
	0xF8,
	0xF6,
	0xF4,
	0xF3,
	0xF1,
	0xEF,
	0xED,
	0xEB,
	0xEA,
	0xE8,
	0xE6,
	0xE5,
	0xE3,
	0xE1,
	0xE0,
	0xDE,
	0xDC,
	0xDB,
	0xD9,
	0xD8,
	0xD6,
	0xD4,
	0xD3,
	0xD1,
	0xD0,
	0xCE,
	0xCD,
	0xCB,
	0xCA,
	0xC8,
	0xC7,
	0xC5,
	0xC4,
	0xC3,
	0xC1,
	0xC0,
	0xBE,
	0xBD,
	0xBC,
	0xBA,
	0xB9,
	0xB8,
	0xB6,
	0xB5,
	0xB4,
	0xB2,
	0xB1,
	0xB0,
	0xAF,
	0xAD,
	0xAC,
	0xAB,
	0xAA,
	0xA8,
	0xA7,
	0xA6,
	0xA5,
	0xA4,
	0xA2,
	0xA0,
	0x9E,
	0x9B,
	0x99,
	0x97,
	0x95,
	0x93,
	0x90,
	0x8E,
	0x8C,
	0x8A,
	0x88,
	0x86,
	0x84,
	0x82,
	0x80,
	0x7E,
	0x7D,
	0x7B,
	0x79,
	0x77,
	0x75,
	0x73,
	0x72,
	0x70,
	0x6E,
	0x6D,
	0x6B,
	0x69,
	0x68,
	0x66,
	0x64,
	0x63,
	0x61,
	0x60,
	0x5E,
	0x5D,
	0x5B,
	0x5A,
	0x58,
	0x57,
	0x55,
	0x54,
	0x52,
	0x51,
	0x50,
	0x4E,
	0x4D,
	0x4C,
	0x4A,
	0x49,
	0x48,
	0x46,
	0x45,
	0x44,
	0x43,
	0x41,
	0x40,
	0x3F,
	0x3E,
	0x3D,
	0x3B,
	0x3A,
	0x39,
	0x38,
	0x37,
	0x36,
	0x34,
	0x33,
	0x32,
	0x31,
	0x30,
	0x2F,
	0x2E,
	0x2D,
	0x2C,
	0x2B,
	0x2A,
	0x29,
	0x28,
	0x27,
	0x26,
	0x25,
	0x24,
	0x23,
	0x22,
	0x21,
	0x20,
	0x1F,
	0x1E,
	0x1D,
	0x1C,
	0x1B,
	0x1A,
	0x1A,
	0x19,
	0x18,
	0x17,
	0x16,
	0x15,
	0x14,
	0x13,
	0x13,
	0x12,
	0x11,
	0x10,
	0xF,
	0xF,
	0xE,
	0xD,
	0xC,
	0xB,
	0xB,
	0xA,
	0x9,
	0x8,
	0x7,
	0x7,
	0x6,
	0x5,
	0x5,
	0x4,
	0x3,
	0x2,
	0x2,
	0x1,
	0x0
};
/*
* WDR S3 table confiuration
*/
int ISP_2K_WDR_S3_TABLE[1024] =
{
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1006,
	0x10DE,
	0x11B0,
	0x127C,
	0x1341,
	0x1401,
	0x14BC,
	0x1571,
	0x1621,
	0x16CC,
	0x1772,
	0x1813,
	0x18B0,
	0x1949,
	0x19DD,
	0x1A6D,
	0x1AF9,
	0x1B81,
	0x1C05,
	0x1C85,
	0x1D02,
	0x1D7C,
	0x1DF2,
	0x1E65,
	0x1ED4,
	0x1F41,
	0x1FAB,
	0x2011,
	0x2075,
	0x20D6,
	0x2135,
	0x2191,
	0x21EA,
	0x2241,
	0x2296,
	0x22E8,
	0x2338,
	0x2386,
	0x23D1,
	0x241B,
	0x2463,
	0x24A8,
	0x24EC,
	0x252E,
	0x256E,
	0x25AC,
	0x25E8,
	0x2623,
	0x265D,
	0x2694,
	0x26CA,
	0x26FF,
	0x2732,
	0x2764,
	0x2794,
	0x27C3,
	0x27F0,
	0x281D,
	0x2848,
	0x2872,
	0x289A,
	0x28C2,
	0x28E8,
	0x290D,
	0x2931,
	0x2954,
	0x2976,
	0x2998,
	0x29B8,
	0x29D7,
	0x29F5,
	0x2A12,
	0x2A2E,
	0x2A4A,
	0x2A64,
	0x2A7E,
	0x2A97,
	0x2AAF,
	0x2AC7,
	0x2ADE,
	0x2AF3,
	0x2B09,
	0x2B1D,
	0x2B31,
	0x2B44,
	0x2B57,
	0x2B68,
	0x2B7A,
	0x2B8A,
	0x2B9A,
	0x2BAA,
	0x2BB9,
	0x2BC7,
	0x2BD5,
	0x2BE2,
	0x2BEF,
	0x2BFB,
	0x2C07,
	0x2C12,
	0x2C1D,
	0x2C27,
	0x2C31,
	0x2C3A,
	0x2C43,
	0x2C4C,
	0x2C54,
	0x2C5B,
	0x2C63,
	0x2C6A,
	0x2C70,
	0x2C76,
	0x2C7C,
	0x2C81,
	0x2C87,
	0x2C8B,
	0x2C90,
	0x2C94,
	0x2C98,
	0x2C9B,
	0x2C9E,
	0x2CA1,
	0x2CA4,
	0x2CA6,
	0x2CA8,
	0x2CAA,
	0x2CAB,
	0x2CAC,
	0x2CAD,
	0x2CAE,
	0x2CAF,
	0x2CAF,
	0x2CAD,
	0x2CAB,
	0x2CA8,
	0x2CA5,
	0x2CA0,
	0x2C9B,
	0x2C96,
	0x2C8F,
	0x2C88,
	0x2C80,
	0x2C78,
	0x2C6F,
	0x2C66,
	0x2C5C,
	0x2C51,
	0x2C47,
	0x2C3B,
	0x2C30,
	0x2C23,
	0x2C17,
	0x2C0A,
	0x2BFD,
	0x2BEF,
	0x2BE1,
	0x2BD3,
	0x2BC5,
	0x2BB6,
	0x2BA7,
	0x2B97,
	0x2B88,
	0x2B78,
	0x2B68,
	0x2B58,
	0x2B47,
	0x2B36,
	0x2B26,
	0x2B15,
	0x2B03,
	0x2AF2,
	0x2AE1,
	0x2ACF,
	0x2ABD,
	0x2AAB,
	0x2A99,
	0x2A87,
	0x2A75,
	0x2A63,
	0x2A50,
	0x2A3E,
	0x2A2B,
	0x2A18,
	0x2A06,
	0x29F3,
	0x29E0,
	0x29CD,
	0x29BA,
	0x29A7,
	0x2994,
	0x2981,
	0x296E,
	0x295B,
	0x2947,
	0x2934,
	0x2921,
	0x290E,
	0x28FA,
	0x28E7,
	0x28D4,
	0x28C0,
	0x28AD,
	0x289A,
	0x2886,
	0x2873,
	0x2860,
	0x284C,
	0x2839,
	0x2826,
	0x2813,
	0x27FF,
	0x27EC,
	0x27D9,
	0x27C6,
	0x27B2,
	0x279F,
	0x278C,
	0x2779,
	0x2766,
	0x2753,
	0x2740,
	0x272D,
	0x271A,
	0x2707,
	0x26F4,
	0x26E1,
	0x26CE,
	0x26BB,
	0x26A9,
	0x2696,
	0x2683,
	0x2671,
	0x265E,
	0x264B,
	0x2639,
	0x2626,
	0x2614,
	0x2602,
	0x25EF,
	0x25DD,
	0x25CB,
	0x25B9,
	0x25A6,
	0x2594,
	0x2582,
	0x2570,
	0x255E,
	0x254C,
	0x253A,
	0x2529,
	0x2517,
	0x2505,
	0x24F4,
	0x24E2,
	0x24D0,
	0x24BF,
	0x24AD,
	0x249C,
	0x2479,
	0x2457,
	0x2435,
	0x2413,
	0x23F1,
	0x23CF,
	0x23AE,
	0x238D,
	0x236C,
	0x234B,
	0x232B,
	0x230B,
	0x22EB,
	0x22CB,
	0x22AB,
	0x228C,
	0x226C,
	0x224D,
	0x222F,
	0x2210,
	0x21F2,
	0x21D4,
	0x21B6,
	0x2198,
	0x217A,
	0x215D,
	0x2140,
	0x2123,
	0x2106,
	0x20EA,
	0x20CD,
	0x20B1,
	0x2095,
	0x2079,
	0x205E,
	0x2042,
	0x2027,
	0x200C,
	0x1FF1,
	0x1FD7,
	0x1FBC,
	0x1FA2,
	0x1F88,
	0x1F6E,
	0x1F54,
	0x1F3B,
	0x1F21,
	0x1F08,
	0x1EEF,
	0x1ED6,
	0x1EBE,
	0x1EA5,
	0x1E8D,
	0x1E74,
	0x1E5C,
	0x1E45,
	0x1E2D,
	0x1E15,
	0x1DFE,
	0x1DE7,
	0x1DD0,
	0x1DB9,
	0x1DA2,
	0x1D8B,
	0x1D75,
	0x1D5E,
	0x1D48,
	0x1D32,
	0x1D1C,
	0x1D07,
	0x1CF1,
	0x1CDB,
	0x1CC6,
	0x1CB1,
	0x1C9C,
	0x1C87,
	0x1C72,
	0x1C5E,
	0x1C49,
	0x1C35,
	0x1C20,
	0x1C0C,
	0x1BF8,
	0x1BE4,
	0x1BD1,
	0x1BBD,
	0x1BAA,
	0x1B96,
	0x1B83,
	0x1B70,
	0x1B5D,
	0x1B4A,
	0x1B37,
	0x1B24,
	0x1B12,
	0x1AFF,
	0x1AED,
	0x1ADB,
	0x1AC9,
	0x1AB7,
	0x1AA5,
	0x1A93,
	0x1A81,
	0x1A70,
	0x1A5E,
	0x1A4D,
	0x1A3C,
	0x1A2B,
	0x1A19,
	0x1A09,
	0x19F8,
	0x19E7,
	0x19D6,
	0x19C6,
	0x19B5,
	0x19A5,
	0x1995,
	0x1984,
	0x1974,
	0x1964,
	0x1954,
	0x1945,
	0x1935,
	0x1925,
	0x1916,
	0x1906,
	0x18F7,
	0x18E8,
	0x18C9,
	0x18AB,
	0x188E,
	0x1870,
	0x1853,
	0x1837,
	0x181A,
	0x17FE,
	0x17E2,
	0x17C7,
	0x17AC,
	0x1791,
	0x1776,
	0x175C,
	0x1742,
	0x1728,
	0x170E,
	0x16F5,
	0x16DC,
	0x16C3,
	0x16AB,
	0x1693,
	0x167B,
	0x1663,
	0x164B,
	0x1634,
	0x161D,
	0x1606,
	0x15EF,
	0x15D9,
	0x15C2,
	0x15AC,
	0x1597,
	0x1581,
	0x156C,
	0x1556,
	0x1541,
	0x152C,
	0x1518,
	0x1503,
	0x14EF,
	0x14DB,
	0x14C7,
	0x14B3,
	0x14A0,
	0x148C,
	0x1479,
	0x1466,
	0x1453,
	0x1441,
	0x142E,
	0x141C,
	0x1409,
	0x13F7,
	0x13E5,
	0x13D4,
	0x13C2,
	0x13B1,
	0x139F,
	0x138E,
	0x137D,
	0x136C,
	0x135B,
	0x134B,
	0x133A,
	0x132A,
	0x131A,
	0x1309,
	0x12FA,
	0x12EA,
	0x12DA,
	0x12CA,
	0x12BB,
	0x12AB,
	0x129C,
	0x128D,
	0x127E,
	0x126F,
	0x1260,
	0x1252,
	0x1243,
	0x1235,
	0x1226,
	0x1218,
	0x120A,
	0x11FC,
	0x11EE,
	0x11E0,
	0x11D3,
	0x11C5,
	0x11B7,
	0x11AA,
	0x119D,
	0x118F,
	0x1182,
	0x1175,
	0x1168,
	0x115B,
	0x114F,
	0x1142,
	0x1135,
	0x1129,
	0x111C,
	0x1110,
	0x1104,
	0x10F8,
	0x10EC,
	0x10E0,
	0x10D4,
	0x10C8,
	0x10BC,
	0x10B0,
	0x10A5,
	0x1099,
	0x108E,
	0x1082,
	0x1077,
	0x106C,
	0x1061,
	0x1056,
	0x104B,
	0x1040,
	0x1035,
	0x102A,
	0x101F,
	0x1015,
	0x100A
};
/**********************************************************************
* 2 frame wdr coff
***********************************************************************/
/*
*WDR L2 table confiuration
*/
int ISP_2K_WDR_L2_TABLE[1024]=
{       
    0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0xFF6,
	0xFE4,
	0xFD2,
	0xFC1,
	0xFAF,
	0xF9E,
	0xF8D,
	0xF7C,
	0xF6B,
	0xF5A,
	0xF49,
	0xF39,
	0xF29,
	0xF19,
	0xF09,
	0xEF9,
	0xEE9,
	0xEDA,
	0xECA,
	0xEBB,
	0xEAC,
	0xE9D,
	0xE8E,
	0xE7F,
	0xE70,
	0xE62,
	0xE53,
	0xE45,
	0xE37,
	0xE29,
	0xE1B,
	0xE0D,
	0xDFF,
	0xDF2,
	0xDE4,
	0xDD7,
	0xDCA,
	0xDBC,
	0xDAF,
	0xDA2,
	0xD96,
	0xD89,
	0xD7C,
	0xD70,
	0xD63,
	0xD57,
	0xD4A,
	0xD3E,
	0xD32,
	0xD26,
	0xD1A,
	0xD0E,
	0xD03,
	0xCF7,
	0xCEB,
	0xCE0,
	0xCD4,
	0xCC9,
	0xCBE,
	0xCB3,
	0xCA8,
	0xC92,
	0xC7C,
	0xC67,
	0xC52,
	0xC3D,
	0xC29,
	0xC15,
	0xC01,
	0xBED,
	0xBDA,
	0xBC7,
	0xBB4,
	0xBA1,
	0xB8F,
	0xB7D,
	0xB6B,
	0xB59,
	0xB48,
	0xB37,
	0xB26,
	0xB15,
	0xB04,
	0xAF4,
	0xAE4,
	0xAD4,
	0xAC4,
	0xAB4,
	0xAA5,
	0xA96,
	0xA86,
	0xA78,
	0xA69,
	0xA5A,
	0xA4C,
	0xA3E,
	0xA30,
	0xA22,
	0xA14,
	0xA06,
	0x9F9,
	0x9EC,
	0x9DE,
	0x9D1,
	0x9C5,
	0x9B8,
	0x9AB,
	0x99F,
	0x992,
	0x986,
	0x97A,
	0x96E,
	0x962,
	0x956,
	0x94B,
	0x93F,
	0x934,
	0x929,
	0x91E,
	0x912,
	0x908,
	0x8FD,
	0x8F2,
	0x8E7,
	0x8DD,
	0x8D2,
	0x8C8,
	0x8BE,
	0x8B4,
	0x8AA,
	0x8A0,
	0x896,
	0x88C,
	0x882,
	0x879,
	0x86F,
	0x866,
	0x85D,
	0x853,
	0x84A,
	0x841,
	0x838,
	0x82F,
	0x826,
	0x81E,
	0x815,
	0x80C,
	0x804,
	0x7FB,
	0x7F3,
	0x7EA,
	0x7E2,
	0x7DA,
	0x7D2,
	0x7CA,
	0x7C2,
	0x7BA,
	0x7B2,
	0x7AA,
	0x7A2,
	0x79B,
	0x793,
	0x78C,
	0x784,
	0x77D,
	0x775,
	0x76E,
	0x767,
	0x760,
	0x758,
	0x751,
	0x74A,
	0x743,
	0x73C,
	0x735,
	0x72F,
	0x728,
	0x721,
	0x71A,
	0x714,
	0x70D,
	0x707,
	0x700,
	0x6FA,
	0x6F3,
	0x6ED,
	0x6E7,
	0x6E0,
	0x6DA,
	0x6CE,
	0x6C2,
	0x6B6,
	0x6AA,
	0x69F,
	0x693,
	0x688,
	0x67D,
	0x672,
	0x667,
	0x65C,
	0x651,
	0x647,
	0x63D,
	0x633,
	0x628,
	0x61F,
	0x615,
	0x60B,
	0x602,
	0x5F8,
	0x5EF,
	0x5E6,
	0x5DC,
	0x5D3,
	0x5CB,
	0x5C2,
	0x5B9,
	0x5B1,
	0x5A8,
	0x5A0,
	0x597,
	0x58F,
	0x587,
	0x57F,
	0x577,
	0x56F,
	0x568,
	0x560,
	0x558,
	0x551,
	0x54A,
	0x542,
	0x53B,
	0x534,
	0x52D,
	0x526,
	0x51F,
	0x518,
	0x511,
	0x50A,
	0x503,
	0x4FD,
	0x4F6,
	0x4F0,
	0x4E9,
	0x4E3,
	0x4DD,
	0x4D7,
	0x4D0,
	0x4CA,
	0x4C4,
	0x4BE,
	0x4B8,
	0x4B2,
	0x4AD,
	0x4A7,
	0x4A1,
	0x49B,
	0x496,
	0x490,
	0x48B,
	0x485,
	0x480,
	0x47A,
	0x475,
	0x470,
	0x46B,
	0x465,
	0x460,
	0x45B,
	0x456,
	0x451,
	0x44C,
	0x447,
	0x442,
	0x43E,
	0x439,
	0x434,
	0x42F,
	0x42B,
	0x426,
	0x421,
	0x41D,
	0x418,
	0x414,
	0x40F,
	0x40B,
	0x407,
	0x402,
	0x3FE,
	0x3FA,
	0x3F5,
	0x3F1,
	0x3ED,
	0x3E9,
	0x3E5,
	0x3E1,
	0x3DD,
	0x3D9,
	0x3D5,
	0x3D1,
	0x3CD,
	0x3C9,
	0x3C5,
	0x3C1,
	0x3BD,
	0x3B9,
	0x3B6,
	0x3B2,
	0x3AE,
	0x3AB,
	0x3A7,
	0x3A3,
	0x3A0,
	0x39C,
	0x399,
	0x395,
	0x38E,
	0x387,
	0x380,
	0x37A,
	0x373,
	0x36D,
	0x366,
	0x360,
	0x35A,
	0x354,
	0x34D,
	0x347,
	0x341,
	0x33C,
	0x336,
	0x330,
	0x32A,
	0x325,
	0x31F,
	0x31A,
	0x315,
	0x30F,
	0x30A,
	0x305,
	0x300,
	0x2FB,
	0x2F6,
	0x2F1,
	0x2EC,
	0x2E7,
	0x2E2,
	0x2DE,
	0x2D9,
	0x2D4,
	0x2D0,
	0x2CB,
	0x2C7,
	0x2C2,
	0x2BE,
	0x2BA,
	0x2B5,
	0x2B1,
	0x2AD,
	0x2A9,
	0x2A5,
	0x2A1,
	0x29D,
	0x299,
	0x295,
	0x291,
	0x28D,
	0x289,
	0x285,
	0x282,
	0x27E,
	0x27A,
	0x277,
	0x273,
	0x26F,
	0x26C,
	0x268,
	0x265,
	0x262,
	0x25E,
	0x25B,
	0x257,
	0x254,
	0x251,
	0x24E,
	0x24A,
	0x247,
	0x244,
	0x241,
	0x23E,
	0x23B,
	0x238,
	0x235,
	0x232,
	0x22F,
	0x22C,
	0x229,
	0x226,
	0x223,
	0x220,
	0x21D,
	0x21B,
	0x218,
	0x215,
	0x212,
	0x210,
	0x20D,
	0x20A,
	0x208,
	0x205,
	0x203,
	0x200,
	0x1FD,
	0x1FB,
	0x1F8,
	0x1F6,
	0x1F3,
	0x1F1,
	0x1EF,
	0x1EC,
	0x1EA,
	0x1E7,
	0x1E5,
	0x1E3,
	0x1E0,
	0x1DE,
	0x1DC,
	0x1D9,
	0x1D7,
	0x1D5,
	0x1D3,
	0x1D0,
	0x1CE,
	0x1CC,
	0x1CA,
	0x1C8,
	0x1C6,
	0x1C4,
	0x1C1,
	0x1BF,
	0x1BD,
	0x1BB,
	0x1B9,
	0x1B7,
	0x1B3,
	0x1AF,
	0x1AB,
	0x1A7,
	0x1A4,
	0x1A0,
	0x19C,
	0x199,
	0x195,
	0x191,
	0x18E,
	0x18A,
	0x187,
	0x184,
	0x180,
	0x17D,
	0x17A,
	0x177,
	0x173,
	0x170,
	0x16D,
	0x16A,
	0x167,
	0x164,
	0x161,
	0x15E,
	0x15B,
	0x158,
	0x156,
	0x153,
	0x150,
	0x14D,
	0x14B,
	0x148,
	0x145,
	0x143,
	0x140,
	0x13E,
	0x13B,
	0x139,
	0x136,
	0x134,
	0x131,
	0x12F,
	0x12C,
	0x12A,
	0x128,
	0x125,
	0x123,
	0x121,
	0x11F,
	0x11C,
	0x11A,
	0x118,
	0x116,
	0x114,
	0x112,
	0x110,
	0x10E,
	0x10C,
	0x10A,
	0x108,
	0x106,
	0x104,
	0x102,
	0x100,
	0xFE,
	0xFC,
	0xFA,
	0xF8,
	0xF6,
	0xF4,
	0xF3,
	0xF1,
	0xEF,
	0xED,
	0xEB,
	0xEA,
	0xE8,
	0xE6,
	0xE5,
	0xE3,
	0xE1,
	0xE0,
	0xDE,
	0xDC,
	0xDB,
	0xD9,
	0xD8,
	0xD6,
	0xD4,
	0xD3,
	0xD1,
	0xD0,
	0xCE,
	0xCD,
	0xCB,
	0xCA,
	0xC8,
	0xC7,
	0xC5,
	0xC4,
	0xC3,
	0xC1,
	0xC0,
	0xBE,
	0xBD,
	0xBC,
	0xBA,
	0xB9,
	0xB8,
	0xB6,
	0xB5,
	0xB4,
	0xB2,
	0xB1,
	0xB0,
	0xAF,
	0xAD,
	0xAC,
	0xAB,
	0xAA,
	0xA8,
	0xA7,
	0xA6,
	0xA5,
	0xA4,
	0xA2,
	0xA0,
	0x9E,
	0x9B,
	0x99,
	0x97,
	0x95,
	0x93,
	0x90,
	0x8E,
	0x8C,
	0x8A,
	0x88,
	0x86,
	0x84,
	0x82,
	0x80,
	0x7E,
	0x7D,
	0x7B,
	0x79,
	0x77,
	0x75,
	0x73,
	0x72,
	0x70,
	0x6E,
	0x6D,
	0x6B,
	0x69,
	0x68,
	0x66,
	0x64,
	0x63,
	0x61,
	0x60,
	0x5E,
	0x5D,
	0x5B,
	0x5A,
	0x58,
	0x57,
	0x55,
	0x54,
	0x52,
	0x51,
	0x50,
	0x4E,
	0x4D,
	0x4C,
	0x4A,
	0x49,
	0x48,
	0x46,
	0x45,
	0x44,
	0x43,
	0x41,
	0x40,
	0x3F,
	0x3E,
	0x3D,
	0x3B,
	0x3A,
	0x39,
	0x38,
	0x37,
	0x36,
	0x34,
	0x33,
	0x32,
	0x31,
	0x30,
	0x2F,
	0x2E,
	0x2D,
	0x2C,
	0x2B,
	0x2A,
	0x29,
	0x28,
	0x27,
	0x26,
	0x25,
	0x24,
	0x23,
	0x22,
	0x21,
	0x20,
	0x1F,
	0x1E,
	0x1D,
	0x1C,
	0x1B,
	0x1A,
	0x1A,
	0x19,
	0x18,
	0x17,
	0x16,
	0x15,
	0x14,
	0x13,
	0x13,
	0x12,
	0x11,
	0x10,
	0xF,
	0xF,
	0xE,
	0xD,
	0xC,
	0xB,
	0xB,
	0xA,
	0x9,
	0x8,
	0x7,
	0x7,
	0x6,
	0x5,
	0x5,
	0x4,
	0x3,
	0x2,
	0x2,
	0x1,
	0x0
};
/*
* WDR S2 table confiuration
*/
int ISP_2K_WDR_S2_TABLE[1024]=
{
    0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1006,
	0x10DE,
	0x11B0,
	0x127C,
	0x1341,
	0x1401,
	0x14BC,
	0x1571,
	0x1621,
	0x16CC,
	0x1772,
	0x1813,
	0x18B0,
	0x1949,
	0x19DD,
	0x1A6D,
	0x1AF9,
	0x1B81,
	0x1C05,
	0x1C85,
	0x1D02,
	0x1D7C,
	0x1DF2,
	0x1E65,
	0x1ED4,
	0x1F41,
	0x1FAB,
	0x2011,
	0x2075,
	0x20D6,
	0x2135,
	0x2191,
	0x21EA,
	0x2241,
	0x2296,
	0x22E8,
	0x2338,
	0x2386,
	0x23D1,
	0x241B,
	0x2463,
	0x24A8,
	0x24EC,
	0x252E,
	0x256E,
	0x25AC,
	0x25E8,
	0x2623,
	0x265D,
	0x2694,
	0x26CA,
	0x26FF,
	0x2732,
	0x2764,
	0x2794,
	0x27C3,
	0x27F0,
	0x281D,
	0x2848,
	0x2872,
	0x289A,
	0x28C2,
	0x28E8,
	0x290D,
	0x2931,
	0x2954,
	0x2976,
	0x2998,
	0x29B8,
	0x29D7,
	0x29F5,
	0x2A12,
	0x2A2E,
	0x2A4A,
	0x2A64,
	0x2A7E,
	0x2A97,
	0x2AAF,
	0x2AC7,
	0x2ADE,
	0x2AF3,
	0x2B09,
	0x2B1D,
	0x2B31,
	0x2B44,
	0x2B57,
	0x2B68,
	0x2B7A,
	0x2B8A,
	0x2B9A,
	0x2BAA,
	0x2BB9,
	0x2BC7,
	0x2BD5,
	0x2BE2,
	0x2BEF,
	0x2BFB,
	0x2C07,
	0x2C12,
	0x2C1D,
	0x2C27,
	0x2C31,
	0x2C3A,
	0x2C43,
	0x2C4C,
	0x2C54,
	0x2C5B,
	0x2C63,
	0x2C6A,
	0x2C70,
	0x2C76,
	0x2C7C,
	0x2C81,
	0x2C87,
	0x2C8B,
	0x2C90,
	0x2C94,
	0x2C98,
	0x2C9B,
	0x2C9E,
	0x2CA1,
	0x2CA4,
	0x2CA6,
	0x2CA8,
	0x2CAA,
	0x2CAB,
	0x2CAC,
	0x2CAD,
	0x2CAE,
	0x2CAF,
	0x2CAF,
	0x2CAD,
	0x2CAB,
	0x2CA8,
	0x2CA5,
	0x2CA0,
	0x2C9B,
	0x2C96,
	0x2C8F,
	0x2C88,
	0x2C80,
	0x2C78,
	0x2C6F,
	0x2C66,
	0x2C5C,
	0x2C51,
	0x2C47,
	0x2C3B,
	0x2C30,
	0x2C23,
	0x2C17,
	0x2C0A,
	0x2BFD,
	0x2BEF,
	0x2BE1,
	0x2BD3,
	0x2BC5,
	0x2BB6,
	0x2BA7,
	0x2B97,
	0x2B88,
	0x2B78,
	0x2B68,
	0x2B58,
	0x2B47,
	0x2B36,
	0x2B26,
	0x2B15,
	0x2B03,
	0x2AF2,
	0x2AE1,
	0x2ACF,
	0x2ABD,
	0x2AAB,
	0x2A99,
	0x2A87,
	0x2A75,
	0x2A63,
	0x2A50,
	0x2A3E,
	0x2A2B,
	0x2A18,
	0x2A06,
	0x29F3,
	0x29E0,
	0x29CD,
	0x29BA,
	0x29A7,
	0x2994,
	0x2981,
	0x296E,
	0x295B,
	0x2947,
	0x2934,
	0x2921,
	0x290E,
	0x28FA,
	0x28E7,
	0x28D4,
	0x28C0,
	0x28AD,
	0x289A,
	0x2886,
	0x2873,
	0x2860,
	0x284C,
	0x2839,
	0x2826,
	0x2813,
	0x27FF,
	0x27EC,
	0x27D9,
	0x27C6,
	0x27B2,
	0x279F,
	0x278C,
	0x2779,
	0x2766,
	0x2753,
	0x2740,
	0x272D,
	0x271A,
	0x2707,
	0x26F4,
	0x26E1,
	0x26CE,
	0x26BB,
	0x26A9,
	0x2696,
	0x2683,
	0x2671,
	0x265E,
	0x264B,
	0x2639,
	0x2626,
	0x2614,
	0x2602,
	0x25EF,
	0x25DD,
	0x25CB,
	0x25B9,
	0x25A6,
	0x2594,
	0x2582,
	0x2570,
	0x255E,
	0x254C,
	0x253A,
	0x2529,
	0x2517,
	0x2505,
	0x24F4,
	0x24E2,
	0x24D0,
	0x24BF,
	0x24AD,
	0x249C,
	0x2479,
	0x2457,
	0x2435,
	0x2413,
	0x23F1,
	0x23CF,
	0x23AE,
	0x238D,
	0x236C,
	0x234B,
	0x232B,
	0x230B,
	0x22EB,
	0x22CB,
	0x22AB,
	0x228C,
	0x226C,
	0x224D,
	0x222F,
	0x2210,
	0x21F2,
	0x21D4,
	0x21B6,
	0x2198,
	0x217A,
	0x215D,
	0x2140,
	0x2123,
	0x2106,
	0x20EA,
	0x20CD,
	0x20B1,
	0x2095,
	0x2079,
	0x205E,
	0x2042,
	0x2027,
	0x200C,
	0x1FF1,
	0x1FD7,
	0x1FBC,
	0x1FA2,
	0x1F88,
	0x1F6E,
	0x1F54,
	0x1F3B,
	0x1F21,
	0x1F08,
	0x1EEF,
	0x1ED6,
	0x1EBE,
	0x1EA5,
	0x1E8D,
	0x1E74,
	0x1E5C,
	0x1E45,
	0x1E2D,
	0x1E15,
	0x1DFE,
	0x1DE7,
	0x1DD0,
	0x1DB9,
	0x1DA2,
	0x1D8B,
	0x1D75,
	0x1D5E,
	0x1D48,
	0x1D32,
	0x1D1C,
	0x1D07,
	0x1CF1,
	0x1CDB,
	0x1CC6,
	0x1CB1,
	0x1C9C,
	0x1C87,
	0x1C72,
	0x1C5E,
	0x1C49,
	0x1C35,
	0x1C20,
	0x1C0C,
	0x1BF8,
	0x1BE4,
	0x1BD1,
	0x1BBD,
	0x1BAA,
	0x1B96,
	0x1B83,
	0x1B70,
	0x1B5D,
	0x1B4A,
	0x1B37,
	0x1B24,
	0x1B12,
	0x1AFF,
	0x1AED,
	0x1ADB,
	0x1AC9,
	0x1AB7,
	0x1AA5,
	0x1A93,
	0x1A81,
	0x1A70,
	0x1A5E,
	0x1A4D,
	0x1A3C,
	0x1A2B,
	0x1A19,
	0x1A09,
	0x19F8,
	0x19E7,
	0x19D6,
	0x19C6,
	0x19B5,
	0x19A5,
	0x1995,
	0x1984,
	0x1974,
	0x1964,
	0x1954,
	0x1945,
	0x1935,
	0x1925,
	0x1916,
	0x1906,
	0x18F7,
	0x18E8,
	0x18C9,
	0x18AB,
	0x188E,
	0x1870,
	0x1853,
	0x1837,
	0x181A,
	0x17FE,
	0x17E2,
	0x17C7,
	0x17AC,
	0x1791,
	0x1776,
	0x175C,
	0x1742,
	0x1728,
	0x170E,
	0x16F5,
	0x16DC,
	0x16C3,
	0x16AB,
	0x1693,
	0x167B,
	0x1663,
	0x164B,
	0x1634,
	0x161D,
	0x1606,
	0x15EF,
	0x15D9,
	0x15C2,
	0x15AC,
	0x1597,
	0x1581,
	0x156C,
	0x1556,
	0x1541,
	0x152C,
	0x1518,
	0x1503,
	0x14EF,
	0x14DB,
	0x14C7,
	0x14B3,
	0x14A0,
	0x148C,
	0x1479,
	0x1466,
	0x1453,
	0x1441,
	0x142E,
	0x141C,
	0x1409,
	0x13F7,
	0x13E5,
	0x13D4,
	0x13C2,
	0x13B1,
	0x139F,
	0x138E,
	0x137D,
	0x136C,
	0x135B,
	0x134B,
	0x133A,
	0x132A,
	0x131A,
	0x1309,
	0x12FA,
	0x12EA,
	0x12DA,
	0x12CA,
	0x12BB,
	0x12AB,
	0x129C,
	0x128D,
	0x127E,
	0x126F,
	0x1260,
	0x1252,
	0x1243,
	0x1235,
	0x1226,
	0x1218,
	0x120A,
	0x11FC,
	0x11EE,
	0x11E0,
	0x11D3,
	0x11C5,
	0x11B7,
	0x11AA,
	0x119D,
	0x118F,
	0x1182,
	0x1175,
	0x1168,
	0x115B,
	0x114F,
	0x1142,
	0x1135,
	0x1129,
	0x111C,
	0x1110,
	0x1104,
	0x10F8,
	0x10EC,
	0x10E0,
	0x10D4,
	0x10C8,
	0x10BC,
	0x10B0,
	0x10A5,
	0x1099,
	0x108E,
	0x1082,
	0x1077,
	0x106C,
	0x1061,
	0x1056,
	0x104B,
	0x1040,
	0x1035,
	0x102A,
	0x101F,
	0x1015,
	0x100A
};
/*
*WDR L2 table confiuration
*/
int ISP_2K_WDR2_L2_TABLE[1024]=
{
    0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0x1000,
	0xFFD,
	0xFEA,
	0xFD8,
	0xFC5,
	0xFB3,
	0xFA1,
	0xF8F,
	0xF7D,
	0xF6C,
	0xF5A,
	0xF49,
	0xF37,
	0xF26,
	0xF15,
	0xF04,
	0xEF3,
	0xEE2,
	0xED2,
	0xEC1,
	0xEB1,
	0xEA1,
	0xE91,
	0xE80,
	0xE71,
	0xE61,
	0xE51,
	0xE41,
	0xE32,
	0xE22,
	0xE13,
	0xE04,
	0xDF5,
	0xDE6,
	0xDD7,
	0xDC8,
	0xDB9,
	0xDAB,
	0xD9C,
	0xD8E,
	0xD7F,
	0xD63,
	0xD47,
	0xD2B,
	0xD10,
	0xCF5,
	0xCDA,
	0xCC0,
	0xCA6,
	0xC8C,
	0xC72,
	0xC59,
	0xC40,
	0xC27,
	0xC0F,
	0xBF7,
	0xBDF,
	0xBC8,
	0xBB0,
	0xB99,
	0xB82,
	0xB6C,
	0xB55,
	0xB3F,
	0xB29,
	0xB14,
	0xAFE,
	0xAE9,
	0xAD4,
	0xABF,
	0xAAB,
	0xA96,
	0xA82,
	0xA6E,
	0xA5A,
	0xA46,
	0xA33,
	0xA20,
	0xA0C,
	0x9F9,
	0x9E7,
	0x9D4,
	0x9C2,
	0x9AF,
	0x99D,
	0x98B,
	0x979,
	0x968,
	0x956,
	0x945,
	0x934,
	0x923,
	0x912,
	0x901,
	0x8F0,
	0x8E0,
	0x8CF,
	0x8BF,
	0x8AF,
	0x89F,
	0x88F,
	0x87F,
	0x870,
	0x860,
	0x851,
	0x842,
	0x832,
	0x823,
	0x814,
	0x806,
	0x7F7,
	0x7E8,
	0x7DA,
	0x7CB,
	0x7BD,
	0x7AF,
	0x7A1,
	0x793,
	0x785,
	0x777,
	0x769,
	0x75C,
	0x74E,
	0x741,
	0x733,
	0x726,
	0x719,
	0x70C,
	0x6FF,
	0x6F2,
	0x6E5,
	0x6D8,
	0x6CB,
	0x6BF,
	0x6B2,
	0x6A6,
	0x699,
	0x68D,
	0x681,
	0x675,
	0x668,
	0x65C,
	0x650,
	0x645,
	0x639,
	0x62D,
	0x621,
	0x616,
	0x60A,
	0x5FF,
	0x5F3,
	0x5E8,
	0x5DD,
	0x5D1,
	0x5C6,
	0x5BB,
	0x5B0,
	0x5A5,
	0x59A,
	0x58F,
	0x585,
	0x57A,
	0x56F,
	0x564,
	0x55A,
	0x54F,
	0x545,
	0x53A,
	0x530,
	0x52C,
	0x528,
	0x525,
	0x521,
	0x51D,
	0x519,
	0x514,
	0x510,
	0x50C,
	0x508,
	0x504,
	0x500,
	0x4FC,
	0x4F8,
	0x4F4,
	0x4F0,
	0x4EB,
	0x4E7,
	0x4E3,
	0x4DF,
	0x4DB,
	0x4D6,
	0x4D2,
	0x4CE,
	0x4CA,
	0x4C5,
	0x4C1,
	0x4BD,
	0x4B9,
	0x4B4,
	0x4B0,
	0x4AC,
	0x4A7,
	0x4A3,
	0x49F,
	0x49A,
	0x496,
	0x492,
	0x48D,
	0x489,
	0x484,
	0x480,
	0x47C,
	0x477,
	0x473,
	0x46E,
	0x46A,
	0x465,
	0x461,
	0x45D,
	0x458,
	0x454,
	0x44F,
	0x44B,
	0x446,
	0x442,
	0x43D,
	0x439,
	0x434,
	0x430,
	0x42B,
	0x426,
	0x422,
	0x41D,
	0x419,
	0x414,
	0x410,
	0x40B,
	0x407,
	0x402,
	0x3FD,
	0x3F9,
	0x3F4,
	0x3F0,
	0x3EB,
	0x3E7,
	0x3E2,
	0x3DD,
	0x3D9,
	0x3D4,
	0x3D0,
	0x3CB,
	0x3C6,
	0x3C2,
	0x3BD,
	0x3B8,
	0x3B4,
	0x3AF,
	0x3AB,
	0x3A6,
	0x3A1,
	0x39D,
	0x398,
	0x393,
	0x38F,
	0x38A,
	0x385,
	0x381,
	0x37C,
	0x377,
	0x373,
	0x36E,
	0x369,
	0x365,
	0x360,
	0x35B,
	0x357,
	0x352,
	0x34D,
	0x349,
	0x344,
	0x33F,
	0x33B,
	0x336,
	0x331,
	0x32D,
	0x328,
	0x323,
	0x31F,
	0x31A,
	0x315,
	0x311,
	0x30C,
	0x307,
	0x303,
	0x2FE,
	0x2F9,
	0x2F4,
	0x2EB,
	0x2E2,
	0x2D8,
	0x2CF,
	0x2C6,
	0x2BC,
	0x2B3,
	0x2A9,
	0x2A0,
	0x297,
	0x28D,
	0x284,
	0x27B,
	0x271,
	0x268,
	0x25E,
	0x255,
	0x24C,
	0x242,
	0x239,
	0x230,
	0x226,
	0x21D,
	0x214,
	0x20A,
	0x201,
	0x1F8,
	0x1EE,
	0x1E5,
	0x1DC,
	0x1D3,
	0x1C9,
	0x1C0,
	0x1B7,
	0x1AE,
	0x1A4,
	0x19B,
	0x192,
	0x189,
	0x17F,
	0x176,
	0x16D,
	0x164,
	0x15B,
	0x151,
	0x148,
	0x13F,
	0x136,
	0x12D,
	0x124,
	0x11B,
	0x112,
	0x109,
	0xFF,
	0xF6,
	0xED,
	0xE4,
	0xDB,
	0xD2,
	0xC9,
	0xC0,
	0xB7,
	0xAE,
	0xA5,
	0x9C,
	0x93,
	0x8B,
	0x82,
	0x79,
	0x70,
	0x67,
	0x5E,
	0x55,
	0x4D,
	0x44,
	0x3B,
	0x32,
	0x29,
	0x21,
	0x18,
	0xF,
	0x6,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0
};
/*
*WDR S2 table confiuration
*/	
int ISP_2K_WDR2_S2_TABLE[1024]=
{   
    0x1000,
	0x100C,
	0x1018,
	0x1024,
	0x1030,
	0x103C,
	0x1048,
	0x1054,
	0x1060,
	0x106C,
	0x1078,
	0x1084,
	0x1090,
	0x109C,
	0x10A8,
	0x10B4,
	0x10C0,
	0x10CC,
	0x10D8,
	0x10E4,
	0x10F0,
	0x10FC,
	0x1108,
	0x1114,
	0x1120,
	0x112C,
	0x1138,
	0x1144,
	0x1150,
	0x115C,
	0x1168,
	0x1174,
	0x1180,
	0x118C,
	0x1198,
	0x11A4,
	0x11B0,
	0x11BC,
	0x11C8,
	0x11D4,
	0x11E0,
	0x11EC,
	0x11F8,
	0x1204,
	0x1210,
	0x121C,
	0x1228,
	0x1234,
	0x1240,
	0x124C,
	0x1258,
	0x1264,
	0x1270,
	0x127C,
	0x1288,
	0x1294,
	0x12A0,
	0x12AC,
	0x12B8,
	0x12C4,
	0x12D0,
	0x12DC,
	0x12E8,
	0x12F4,
	0x1300,
	0x130C,
	0x1318,
	0x1324,
	0x1330,
	0x133C,
	0x1348,
	0x1354,
	0x1360,
	0x136C,
	0x1378,
	0x1384,
	0x1390,
	0x139C,
	0x13A8,
	0x13B4,
	0x13C0,
	0x13CC,
	0x13D8,
	0x13E4,
	0x13F0,
	0x13FC,
	0x1408,
	0x1414,
	0x1420,
	0x142C,
	0x1438,
	0x1444,
	0x1450,
	0x145C,
	0x1468,
	0x1474,
	0x1480,
	0x148C,
	0x1498,
	0x14A4,
	0x14B0,
	0x14BC,
	0x14C8,
	0x14D4,
	0x14E0,
	0x14EC,
	0x14F8,
	0x1504,
	0x1510,
	0x151C,
	0x1528,
	0x1534,
	0x1540,
	0x154C,
	0x1558,
	0x1564,
	0x1570,
	0x157C,
	0x1588,
	0x1594,
	0x15A0,
	0x15AC,
	0x15B8,
	0x15C4,
	0x15D0,
	0x15DC,
	0x15E8,
	0x15F4,
	0x1600,
	0x160C,
	0x1618,
	0x1624,
	0x1630,
	0x163C,
	0x1648,
	0x1654,
	0x1660,
	0x166C,
	0x1678,
	0x1684,
	0x1690,
	0x169C,
	0x16A8,
	0x16B4,
	0x16C0,
	0x16CC,
	0x16D8,
	0x16E4,
	0x16F0,
	0x16FC,
	0x1708,
	0x1714,
	0x1720,
	0x172C,
	0x1738,
	0x1744,
	0x1750,
	0x175C,
	0x1768,
	0x1774,
	0x1780,
	0x178C,
	0x1798,
	0x17A4,
	0x17B0,
	0x17BC,
	0x17C8,
	0x17D4,
	0x17E0,
	0x17EC,
	0x17F8,
	0x1804,
	0x1810,
	0x181C,
	0x1828,
	0x1834,
	0x1840,
	0x184C,
	0x1858,
	0x1864,
	0x1870,
	0x187C,
	0x1888,
	0x1894,
	0x18A0,
	0x18AC,
	0x18B8,
	0x18C4,
	0x18D0,
	0x18DC,
	0x18E8,
	0x18F4,
	0x1900,
	0x190C,
	0x1918,
	0x1924,
	0x1930,
	0x193C,
	0x1948,
	0x1954,
	0x1960,
	0x196C,
	0x1978,
	0x1984,
	0x1990,
	0x199C,
	0x19A8,
	0x19B4,
	0x19C0,
	0x19CC,
	0x19D8,
	0x19E4,
	0x19F0,
	0x19FC,
	0x1A08,
	0x1A14,
	0x1A20,
	0x1A2C,
	0x1A38,
	0x1A44,
	0x1A50,
	0x1A5C,
	0x1A68,
	0x1A74,
	0x1A80,
	0x1A8C,
	0x1A98,
	0x1AA4,
	0x1AB0,
	0x1ABC,
	0x1AC8,
	0x1AD4,
	0x1AE0,
	0x1AEC,
	0x1AF8,
	0x1B04,
	0x1B10,
	0x1B1C,
	0x1B28,
	0x1B34,
	0x1B40,
	0x1B4C,
	0x1B58,
	0x1B64,
	0x1B70,
	0x1B7C,
	0x1B88,
	0x1B94,
	0x1BA0,
	0x1BAC,
	0x1BB8,
	0x1BC4,
	0x1BD0,
	0x1BDC,
	0x1BE8,
	0x1BF4,
	0x1C00,
	0x1C18,
	0x1C30,
	0x1C48,
	0x1C60,
	0x1C78,
	0x1C90,
	0x1CA8,
	0x1CC0,
	0x1CD8,
	0x1CF0,
	0x1D08,
	0x1D20,
	0x1D38,
	0x1D50,
	0x1D68,
	0x1D80,
	0x1D98,
	0x1DB0,
	0x1DC8,
	0x1DE0,
	0x1DF8,
	0x1E10,
	0x1E28,
	0x1E40,
	0x1E58,
	0x1E70,
	0x1E88,
	0x1EA0,
	0x1EB8,
	0x1ED0,
	0x1EE8,
	0x1F00,
	0x1F18,
	0x1F30,
	0x1F48,
	0x1F60,
	0x1F78,
	0x1F90,
	0x1FA8,
	0x1FC0,
	0x1FD8,
	0x1FF0,
	0x2008,
	0x2020,
	0x2038,
	0x2050,
	0x2068,
	0x2080,
	0x2098,
	0x20B0,
	0x20C8,
	0x20E0,
	0x20F8,
	0x2110,
	0x2128,
	0x2140,
	0x2158,
	0x2170,
	0x2188,
	0x21A0,
	0x21B8,
	0x21D0,
	0x21E8,
	0x2200,
	0x2218,
	0x2230,
	0x2248,
	0x2260,
	0x2278,
	0x2290,
	0x22A8,
	0x22C0,
	0x22D8,
	0x22F0,
	0x2308,
	0x2320,
	0x2338,
	0x2350,
	0x2368,
	0x2380,
	0x2398,
	0x23B0,
	0x23C8,
	0x23E0,
	0x23F8,
	0x2410,
	0x2428,
	0x2440,
	0x2458,
	0x2470,
	0x2488,
	0x24A0,
	0x24B8,
	0x24D0,
	0x24E8,
	0x2500,
	0x2518,
	0x2530,
	0x2548,
	0x2560,
	0x2578,
	0x2590,
	0x25A8,
	0x25C0,
	0x25D8,
	0x25F0,
	0x2608,
	0x2620,
	0x2638,
	0x2650,
	0x2668,
	0x2680,
	0x2698,
	0x26B0,
	0x26C8,
	0x26E0,
	0x26F8,
	0x2710,
	0x2728,
	0x2740,
	0x2758,
	0x2770,
	0x2788,
	0x27A0,
	0x27B8,
	0x27D0,
	0x27E8,
	0x2800,
	0x2830,
	0x2860,
	0x2890,
	0x28C0,
	0x28F0,
	0x2920,
	0x2950,
	0x2980,
	0x29B0,
	0x29E0,
	0x2A10,
	0x2A40,
	0x2A70,
	0x2AA0,
	0x2AD0,
	0x2B00,
	0x2B30,
	0x2B60,
	0x2B90,
	0x2BC0,
	0x2BF0,
	0x2C20,
	0x2C50,
	0x2C80,
	0x2CB0,
	0x2CE0,
	0x2D10,
	0x2D40,
	0x2D70,
	0x2DA0,
	0x2DD0,
	0x2E00,
	0x2E30,
	0x2E60,
	0x2E90,
	0x2EC0,
	0x2EF0,
	0x2F20,
	0x2F50,
	0x2F80,
	0x2FB0,
	0x2FE0,
	0x3010,
	0x3040,
	0x3070,
	0x30A0,
	0x30D0,
	0x3100,
	0x3130,
	0x3160,
	0x3190,
	0x31C0,
	0x31F0,
	0x3220,
	0x3250,
	0x3280,
	0x32B0,
	0x32E0,
	0x3310,
	0x3340,
	0x3370,
	0x33A0,
	0x33D0,
	0x3400,
	0x3430,
	0x3460,
	0x3490,
	0x34C0,
	0x34F0,
	0x3520,
	0x3550,
	0x3580,
	0x35B0,
	0x35E0,
	0x3610,
	0x3640,
	0x3670,
	0x36A0,
	0x36D0,
	0x3700,
	0x3730,
	0x3760,
	0x3790,
	0x37C0,
	0x37F0,
	0x3820,
	0x3850,
	0x3880,
	0x38B0,
	0x38E0,
	0x3910,
	0x3940,
	0x3970,
	0x39A0,
	0x39D0,
	0x3A00,
	0x3A30,
	0x3A60,
	0x3A90,
	0x3AC0,
	0x3AF0,
	0x3B20,
	0x3B50,
	0x3B80,
	0x3BB0,
	0x3BE0,
	0x3C10,
	0x3C40,
	0x3C70,
	0x3CA0,
	0x3CD0,
	0x3D00,
	0x3D30,
	0x3D60,
	0x3D90,
	0x3DC0,
	0x3DF0,
	0x3E20,
	0x3E50,
	0x3E80,
	0x3EB0,
	0x3EE0,
	0x3F10,
	0x3F40,
	0x3F70,
	0x3FA0,
	0x3FD0,
	0x4000,
	0x3FF9,
	0x3FF3,
	0x3FEC,
	0x3FE6,
	0x3FE0,
	0x3FD9,
	0x3FD3,
	0x3FCC,
	0x3FC6,
	0x3FC0,
	0x3FB9,
	0x3FB3,
	0x3FAC,
	0x3FA6,
	0x3FA0,
	0x3F99,
	0x3F93,
	0x3F8C,
	0x3F86,
	0x3F80,
	0x3F79,
	0x3F73,
	0x3F6C,
	0x3F66,
	0x3F60,
	0x3F59,
	0x3F53,
	0x3F4C,
	0x3F46,
	0x3F40,
	0x3F39,
	0x3F33,
	0x3F2C,
	0x3F26,
	0x3F20,
	0x3F19,
	0x3F13,
	0x3F0C,
	0x3F06,
	0x3F00,
	0x3EF9,
	0x3EF3,
	0x3EEC,
	0x3EE6,
	0x3EE0,
	0x3ED9,
	0x3ED3,
	0x3ECC,
	0x3EC6,
	0x3EC0,
	0x3EB9,
	0x3EB3,
	0x3EAC,
	0x3EA6,
	0x3EA0,
	0x3E99,
	0x3E93,
	0x3E8C,
	0x3E86,
	0x3E80,
	0x3E79,
	0x3E73,
	0x3E6C,
	0x3E66,
	0x3E60,
	0x3E59,
	0x3E53,
	0x3E4C,
	0x3E46,
	0x3E40,
	0x3E39,
	0x3E33,
	0x3E2C,
	0x3E26,
	0x3E20,
	0x3E19,
	0x3E13,
	0x3E0C,
	0x3E06,
	0x3E00,
	0x3DF9,
	0x3DF3,
	0x3DEC,
	0x3DE6,
	0x3DE0,
	0x3DD9,
	0x3DD3,
	0x3DCC,
	0x3DC6,
	0x3DC0,
	0x3DB9,
	0x3DB3,
	0x3DAC,
	0x3DA6,
	0x3DA0,
	0x3D99,
	0x3D93,
	0x3D8C,
	0x3D86,
	0x3D80,
	0x3D79,
	0x3D73,
	0x3D6C,
	0x3D66,
	0x3D60,
	0x3D59,
	0x3D53,
	0x3D4C,
	0x3D46,
	0x3D40,
	0x3D39,
	0x3D33,
	0x3D2C,
	0x3D26,
	0x3D20,
	0x3D19,
	0x3D13,
	0x3D0C,
	0x3D06,
	0x3D00,
	0x3CF9,
	0x3CF3,
	0x3CEC,
	0x3CE6,
	0x3CE0,
	0x3CD9,
	0x3CD3,
	0x3CCC,
	0x3CC0,
	0x3CB3,
	0x3CA6,
	0x3C99,
	0x3C8C,
	0x3C80,
	0x3C73,
	0x3C66,
	0x3C59,
	0x3C4C,
	0x3C40,
	0x3C33,
	0x3C26,
	0x3C19,
	0x3C0C,
	0x3C00,
	0x3BF3,
	0x3BE6,
	0x3BD9,
	0x3BCC,
	0x3BC0,
	0x3BB3,
	0x3BA6,
	0x3B99,
	0x3B8C,
	0x3B80,
	0x3B73,
	0x3B66,
	0x3B59,
	0x3B4C,
	0x3B40,
	0x3B33,
	0x3B26,
	0x3B19,
	0x3B0C,
	0x3B00,
	0x3AF3,
	0x3AE6,
	0x3AD9,
	0x3ACC,
	0x3AC0,
	0x3AB3,
	0x3AA6,
	0x3A99,
	0x3A8C,
	0x3A80,
	0x3A73,
	0x3A66,
	0x3A59,
	0x3A4C,
	0x3A40,
	0x3A33,
	0x3A26,
	0x3A19,
	0x3A0C,
	0x3A00,
	0x39F3,
	0x39E6,
	0x39D9,
	0x39CC,
	0x39C0,
	0x39B3,
	0x39A6,
	0x3999,
	0x398C,
	0x3980,
	0x3973,
	0x3966,
	0x3959,
	0x394C,
	0x3940,
	0x3933,
	0x3926,
	0x3919,
	0x390C,
	0x3900,
	0x38F3,
	0x38E6,
	0x38D9,
	0x38CC,
	0x38C0,
	0x38B3,
	0x389D,
	0x3866,
	0x3830,
	0x37FA,
	0x37C5,
	0x3790,
	0x375C,
	0x3728,
	0x36F4,
	0x36C1,
	0x368E,
	0x365C,
	0x362A,
	0x35F8,
	0x35C7,
	0x3596,
	0x3566,
	0x3536,
	0x3506,
	0x34D7,
	0x34A8,
	0x347A,
	0x344B,
	0x341E,
	0x33F0,
	0x33C3,
	0x3396,
	0x336A,
	0x333E,
	0x3312,
	0x32E7,
	0x32BC,
	0x3291,
	0x3266,
	0x323C,
	0x3212,
	0x31E9,
	0x31C0,
	0x3197,
	0x316E,
	0x3146,
	0x311E,
	0x30F6,
	0x30CE,
	0x30A7,
	0x3080,
	0x3033,
	0x2FE7,
	0x2F9C,
	0x2F52,
	0x2F09,
	0x2EC1,
	0x2E7A,
	0x2E34,
	0x2DEF,
	0x2DAB,
	0x2D68,
	0x2D25,
	0x2CE4,
	0x2CA3,
	0x2C63,
	0x2C24,
	0x2BE5,
	0x2BA8,
	0x2B6B,
	0x2B2F,
	0x2AF3,
	0x2AB9,
	0x2A7F,
	0x2A45,
	0x2A0D,
	0x29D5,
	0x299D,
	0x2967,
	0x2931,
	0x28FB,
	0x28C6,
	0x2892,
	0x285F,
	0x282C,
	0x27F9,
	0x27C7,
	0x2796,
	0x2765,
	0x2734,
	0x2705,
	0x26D5,
	0x26A7,
	0x2678,
	0x264A,
	0x261D,
	0x25F0,
	0x25C4,
	0x2598,
	0x256C,
	0x2541,
	0x2516,
	0x24EC,
	0x24C2,
	0x2499,
	0x2470,
	0x2447,
	0x241F,
	0x23F8,
	0x23D0,
	0x23A9,
	0x2382,
	0x235C,
	0x2336,
	0x2311,
	0x22EB,
	0x22C6,
	0x22A2,
	0x227E,
	0x225A,
	0x2236,
	0x2213,
	0x21F0,
	0x21CE,
	0x21AB,
	0x2189,
	0x2168,
	0x2146,
	0x2125,
	0x2104,
	0x20E4,
	0x20C4,
	0x20A4,
	0x2084,
	0x2064,
	0x2045,
	0x2026,
	0x2008,
	0x1FE9,
	0x1FCB,
	0x1FAD,
	0x1F90,
	0x1F72,
	0x1F55,
	0x1F38,
	0x1F1C,
	0x1EFF,
	0x1EE3,
	0x1EC7,
	0x1EAB,
	0x1E8F,
	0x1E74,
	0x1E59,
	0x1E3E,
	0x1E23,
	0x1E09,
	0x1DEF,
	0x1DD4,
	0x1DBB,
	0x1DA1,
	0x1D87,
	0x1D6E,
	0x1D55,
	0x1D3C,
	0x1D23,
	0x1D0B,
	0x1CF2,
	0x1CDA,
	0x1CC2,
	0x1CAA,
	0x1C93,
	0x1C7B,
	0x1C64,
	0x1C4C,
	0x1C35,
	0x1C1F,
	0x1C08,
	0x1BF1,
	0x1BDB,
	0x1BAF,
	0x1B83,
	0x1B58,
	0x1B2E,
	0x1B04,
	0x1ADA,
	0x1AB2,
	0x1A89,
	0x1A62,
	0x1A3B,
	0x1A14,
	0x19EE,
	0x19C8,
	0x19A3,
	0x197E,
	0x195A,
	0x1936,
	0x1913,
	0x18F0,
	0x18CD,
	0x18AB,
	0x1889,
	0x1868,
	0x1847,
	0x1826,
	0x1806,
	0x17E7,
	0x17C7,
	0x17A8,
	0x1789,
	0x176B,
	0x174D,
	0x172F,
	0x1712,
	0x16F5,
	0x16D8,
	0x16BC,
	0x16A0,
	0x1684,
	0x1669,
	0x164E,
	0x1633,
	0x1618,
	0x15FE,
	0x15E4,
	0x15CA,
	0x15B0,
	0x1597,
	0x157E,
	0x1565,
	0x154D,
	0x1535,
	0x151D,
	0x1505,
	0x14ED,
	0x14D6,
	0x14BF,
	0x14A8,
	0x1491,
	0x147B,
	0x1465,
	0x144F,
	0x1439,
	0x1423,
	0x140E,
	0x13F9,
	0x13E4,
	0x13CF,
	0x13BB,
	0x13A6,
	0x1392,
	0x137E,
	0x136A,
	0x1356,
	0x1343,
	0x132F,
	0x131C,
	0x1309,
	0x12F6,
	0x12E4,
	0x12D1,
	0x12BF,
	0x12AD,
	0x129B,
	0x1289,
	0x1277,
	0x1265,
	0x1254,
	0x1243,
	0x1231,
	0x1220,
	0x120F,
	0x11FF,
	0x11EE,
	0x11DE,
	0x11CD,
	0x11BD,
	0x11AD,
	0x119D,
	0x118D,
	0x117D,
	0x116E,
	0x115E,
	0x114F,
	0x1140,
	0x1131,
	0x1122,
	0x1113,
	0x1104,
	0x10F6,
	0x10E7,
	0x10D9,
	0x10CA,
	0x10BC,
	0x10AE,
	0x10A0,
	0x1092,
	0x1084,
	0x1076,
	0x1069,
	0x105B,
	0x104E,
	0x1041,
	0x1033,
	0x1026,
	0x1019,
	0x100C
};
